## openclonk 5.3.2

=== CMakeLists.txt ===
# OpenClonk, http://www.openclonk.org
#
# Copyright (c) 2009-2011  Günther Brammer
# Copyright (c) 2009-2012  Nicolas Hake
# Copyright (c) 2009  David Dormagen
# Copyright (c) 2009-2012  Armin Burgmeier
# Copyright (c) 2009-2010  Sven Eberhardt
# Copyright (c) 2009  Tobias Zwick
# Copyright (c) 2009  Richard Gerum
# Copyright (c) 2010-2011  Julius Michaelis
# Copyright (c) 2010-2011  Peter Wortmann
# Copyright (c) 2010-2011  Martin Plicht
# Copyright (c) 2010  Manuel Riecke
#
# Portions might be copyrighted by other authors who have contributed
# to OpenClonk.
#
# Permission to use, copy, modify, and/or distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
# See isc_license.txt for full license and disclaimer.
#
# "Clonk" is a registered trademark of Matthes Bender.
# See clonk_trademark_license.txt for full license.

cmake_minimum_required (VERSION 2.6.0)
project (openclonk CXX C)
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include(Version.txt)

set(CMAKE_ADDITIONAL_DEPS_PATH deps CACHE PATH "Additional directory to search for libraries and headers")
list(APPEND CMAKE_PREFIX_PATH ${CMAKE_ADDITIONAL_DEPS_PATH})
set(OC_CXX_FLAGS ${CMAKE_CXX_FLAGS})
separate_arguments(OC_CXX_FLAGS)
set(OC_CXX_FLAGS_DEBUG ${CMAKE_CXX_FLAGS_DEBUG})
separate_arguments(OC_CXX_FLAGS_DEBUG)
set(OC_EXE_LINKER_FLAGS ${CMAKE_EXE_LINKER_FLAGS})
separate_arguments(OC_EXE_LINKER_FLAGS)
set(OC_EXE_LINKER_FLAGS_DEBUG ${CMAKE_EXE_LINKER_FLAGS_DEBUG})
separate_arguments(OC_EXE_LINKER_FLAGS_DEBUG)

############################################################################
# User selectable options
############################################################################
option(PROJECT_FOLDERS "Put source files into subfolders in project file" ON)
option(USE_GL "Enable OpenGL support" ON)
SET(INITIAL_USE_SDL_MAINLOOP_VALUE OFF)
SET(INITIAL_USE_OPEN_AL OFF)
option(USE_SDL_MAINLOOP "Use SDL to create windows etc." ${INITIAL_USE_SDL_MAINLOOP_VALUE})
if(WIN32 AND FALSE) # disable DX option while it doesn't work anyway
	option(USE_DIRECTX "Enable DirectX support" ON)
	if(EXISTS $ENV{DXSDK_DIR})
		list(APPEND CMAKE_INCLUDE_PATH $ENV{DXSDK_DIR}/Include)
		if(CMAKE_CL_64)
			list(APPEND CMAKE_LIBRARY_PATH $ENV{DXSDK_DIR}/Lib/x64)
		else()
			list(APPEND CMAKE_LIBRARY_PATH $ENV{DXSDK_DIR}/Lib/x86)
		endif()
	else()

	endif()
else()
	SET(USE_DIRECTX OFF)
	SET(HAVE_FMOD OFF)
endif()
if(NOT USE_GL AND NOT USE_DIRECTX)
	message(STATUS "No graphics display enabled; building dedicated server")
	SET(USE_CONSOLE ON CACHE INTERNAL "Build dedicated server")
endif()
if(UNIX AND NOT USE_SDL_MAINLOOP AND NOT APPLE AND NOT USE_CONSOLE)
	option(USE_X11 "Use X11 to create windows etc." ON)
	option(USE_GTK "Use GTK for the developer mode" ON)
	option(USE_GTK3 "Use GTK3 instead of GTK2" OFF)
else()
	SET(USE_X11 OFF)
	SET(USE_GTK OFF)
	SET(USE_GTK3 OFF)
endif()
if(APPLE)
	option(USE_COCOA "Use Apple Cocoa for the developer mode and the windows." ON)
	option(USE_APPLE_CLANG "Use Apple Clang Compiler as C++ compiler." ON)
	SET(INITIAL_USE_OPEN_AL ON)
else()
	option(USE_COCOA OFF)
endif()
option(USE_OPEN_AL "Use OpenAL to play sounds" ${INITIAL_USE_OPEN_AL})
option(DEBUGREC "Debug records" OFF)
option(OC_BUILD_MULTIPROCESSOR "Use all processor cores to build" OFF)
option(WITH_AUTOMATIC_UPDATE "Build engine without automatic update support" OFF)

############################################################################
# Check for compiler quirks and features
############################################################################
include(CheckCXXCompilerFlag)
if(CMAKE_COMPILER_IS_GNUCXX)
	CHECK_CXX_COMPILER_FLAG("-std=gnu++0x" USE_GCC_STD_0X)
	if(USE_GCC_STD_0X)
		list(APPEND OC_CXX_FLAGS "-std=gnu++0x")
	endif()
endif()

# ck 09-09-20: CMAKE_REQUIRED_FLAGS requires a string, not a list.
include(CheckCXXSourceCompiles)
foreach(FLAG ${OC_CXX_FLAGS})
	set(OC_REQUIRED_FLAGS "${OC_REQUIRED_FLAGS} ${FLAG}")
endforeach()

# ck 10-09-04: Reset CMAKE_REQUIRED_FLAGS after having done the C++0x checks
# otherwise they are used for C library checks as well and the C compiler bails
# out because it does not understand -std=gnu++0x
set(SAFE_CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS}")
set(CMAKE_REQUIRED_FLAGS ${OC_REQUIRED_FLAGS})
CHECK_CXX_SOURCE_COMPILES("void f(struct D&&); int main() { return 0; }" HAVE_RVALUE_REF)
CHECK_CXX_SOURCE_COMPILES("int main() { void *d = nullptr; }" HAVE_NULLPTR)
CHECK_CXX_SOURCE_COMPILES("int main() { static_assert(true, \"\"); }" HAVE_STATIC_ASSERT)
set(CMAKE_REQUIRED_FLAGS "${SAFE_CMAKE_REQUIRED_FLAGS}")

if(MSVC_VERSION GREATER 1499)
	# Activate minimal rebuild
	if(OC_BUILD_MULTIPROCESSOR)
		list(APPEND OC_CXX_FLAGS /MP)
		list(REMOVE_ITEM OC_CXX_FLAGS_DEBUG /Gm)
	else()
		list(REMOVE_ITEM OC_CXX_FLAGS /MP)
		list(APPEND OC_CXX_FLAGS_DEBUG /Gm)
	endif()
	if (NOT CMAKE_CL_64)
		# Activate edit-and-continue
		list(REMOVE_ITEM OC_CXX_FLAGS_DEBUG /Zi)
		list(APPEND OC_CXX_FLAGS_DEBUG /ZI /Gy)
	endif()
	# do not link the release CRT in debug builds
	list(APPEND OC_EXE_LINKER_FLAGS_DEBUG "/NODEFAULTLIB:MSVCRT")
	set(HAVE_PRECOMPILED_HEADERS ON CACHE INTERNAL "Compiler supports precompiled headers")
endif()
if(MSVC_VERSION)
	# Suppress warnings about "non-secure" functions
	add_definitions(-D_CRT_SECURE_NO_WARNINGS -D_SCL_SECURE_NO_WARNINGS -D_CRT_NONSTDC_NO_WARNINGS)
	# Disable warning C4244: 'conversion' conversion from 'type1' to 'type2', possible loss of data
	list(APPEND OC_CXX_FLAGS "/wd4244")
	# Disable warning C4267: 'var' : conversion from 'size_t' to 'type', possible loss of data (64 bit build only)
	list(APPEND OC_CXX_FLAGS "/wd4267")
endif()

if(CMAKE_COMPILER_IS_GNUCXX)
	list(APPEND OC_CXX_FLAGS "-Wall -Wextra -Wredundant-decls -Wendif-labels -Wpointer-arith -Wcast-qual -Wcast-align -Wwrite-strings -Winit-self -Wsign-promo -Wno-reorder -Wno-unused-parameter -Wnon-virtual-dtor -Woverloaded-virtual")
endif()

if(WIN32 AND MINGW)
	# Activate DEP and ASLR
	list(APPEND OC_EXE_LINKER_FLAGS "-Wl,--nxcompat -Wl,--dynamicbase")
endif()
############################################################################
# List target source files. Don't directly create a target since we condi-
# tionally add more sources depending on configuration options later.
############################################################################
# OC_CLONK_SOURCES: Sources for OpenClonk that are needed by every build.
# OC_SYSTEM_SOURCES: Sources for OpenClonk that are only needed by specific
# 	configurations.
set(OC_CLONK_SOURCES
	src/C4Globals.cpp
	src/c4group/C4ComponentHost.cpp
	src/c4group/C4ComponentHost.h
	src/c4group/C4Components.h
	src/c4group/C4Extra.cpp
	src/c4group/C4Extra.h
	src/c4group/C4Group.cpp
	src/c4group/C4Group.h
	src/c4group/C4GroupSet.cpp
	src/c4group/C4GroupSet.h
	src/c4group/C4LangStringTable.cpp
	src/c4group/C4LangStringTable.h
	src/c4group/C4Language.cpp
	src/c4group/C4Language.h
	src/c4group/C4Update.cpp
	src/c4group/C4Update.h
	src/c4group/CStdFile.cpp
	src/c4group/CStdFile.h
	src/C4Include.h
	src/C4Prototypes.h
	src/C4Version.h
	src/config/C4Config.cpp
	src/config/C4Config.h
	src/config/C4Constants.h
	src/config/C4Reloc.cpp
	src/config/C4Reloc.h
	src/control/C4Control.cpp
	src/control/C4Control.h
	src/control/C4GameControl.cpp
	src/control/C4GameControl.h
	src/control/C4GameParameters.cpp
	src/control/C4GameParameters.h
	src/control/C4GameSave.cpp
	src/control/C4GameSave.h
	src/control/C4PlayerControl.cpp
	src/control/C4PlayerControl.h
	src/control/C4PlayerInfoConflicts.cpp
	src/control/C4PlayerInfo.cpp
	src/control/C4PlayerInfo.h
	src/control/C4Record.cpp
	src/control/C4Record.h
	src/control/C4RoundResults.cpp
	src/control/C4RoundResults.h
	src/control/C4Teams.cpp
	src/control/C4Teams.h
	src/editor/C4Console.cpp
	src/editor/C4ConsoleGUICommon.h
	src/editor/C4ConsoleGUI.h
	src/editor/C4Console.h
	src/editor/C4EditCursor.cpp
	src/editor/C4EditCursor.h
	src/editor/C4ObjectListDlg.cpp
	src/editor/C4ObjectListDlg.h
	src/editor/C4ToolsDlg.cpp
	src/editor/C4ToolsDlg.h
	src/editor/C4ViewportWindow.cpp
	src/editor/C4ViewportWindow.h
	src/game/C4Application.cpp
	src/game/C4Application.h
	src/game/C4FullScreen.cpp
	src/game/C4FullScreen.h
	src/game/C4Game.cpp
	src/game/C4Game.h
	src/game/C4GameVersion.h
	src/game/C4GraphicsSystem.cpp
	src/game/C4GraphicsSystem.h
	src/game/C4Physics.h
	src/game/C4Viewport.cpp
	src/game/C4Viewport.h
	src/gamescript/C4Effect.cpp
	src/gamescript/C4Effect.h
	src/gamescript/C4FindObject.cpp
	src/gamescript/C4FindObject.h
	src/gamescript/C4GameScript.cpp
	src/gamescript/C4Script.h
	src/gamescript/C4TransferZone.cpp
	src/gamescript/C4TransferZone.h
	src/graphics/Bitmap256.cpp
	src/graphics/Bitmap256.h
	src/graphics/C4Draw.cpp
	src/graphics/C4DrawD3D.cpp
	src/graphics/C4DrawD3D.h
	src/graphics/C4DrawD3DShader.cpp
	src/graphics/C4DrawD3DShader.h
	src/graphics/C4DrawGL.cpp
	src/graphics/C4DrawGLCtx.cpp
	src/graphics/C4DrawGL.h
	src/graphics/C4DrawT.cpp
	src/graphics/C4DrawT.h
	src/graphics/C4Draw.h
	src/graphics/C4Facet.cpp
	src/graphics/C4FacetEx.cpp
	src/graphics/C4FacetEx.h
	src/graphics/C4Facet.h
	src/graphics/C4Fonts.cpp
	src/graphics/C4Fonts.h
	src/graphics/C4GraphicsResource.cpp
	src/graphics/C4GraphicsResource.h
	src/graphics/C4Surface.cpp
	src/graphics/C4Surface.h
	src/graphics/C4SurfaceLoaders.cpp
	src/graphics/CSurface8.cpp
	src/graphics/CSurface8.h
	src/graphics/StdPNG.cpp
	src/graphics/StdPNG.h
	src/gui/C4ChatDlg.cpp
	src/gui/C4ChatDlg.h
	src/gui/C4DownloadDlg.cpp
	src/gui/C4DownloadDlg.h
	src/gui/C4FileSelDlg.cpp
	src/gui/C4FileSelDlg.h
	src/gui/C4Folder.cpp
	src/gui/C4Folder.h
	src/gui/C4GameDialogs.cpp
	src/gui/C4GameDialogs.h
	src/gui/C4GameLobby.cpp
	src/gui/C4GameLobby.h
	src/gui/C4GameMessage.cpp
	src/gui/C4GameMessage.h
	src/gui/C4GameOptions.cpp
	src/gui/C4GameOptions.h
	src/gui/C4GameOverDlg.cpp
	src/gui/C4GameOverDlg.h
	src/gui/C4GfxErrorDlg.cpp
	src/gui/C4GfxErrorDlg.h
	src/gui/C4GuiButton.cpp
	src/gui/C4GuiCheckBox.cpp
	src/gui/C4GuiComboBox.cpp
	src/gui/C4GuiContainers.cpp
	src/gui/C4Gui.cpp
	src/gui/C4GuiDialogs.cpp
	src/gui/C4GuiEdit.cpp
	src/gui/C4Gui.h
	src/gui/C4GuiLabels.cpp
	src/gui/C4GuiListBox.cpp
	src/gui/C4GuiMenu.cpp
	src/gui/C4GuiTabular.cpp
	src/gui/C4KeyboardInput.cpp
	src/gui/C4KeyboardInput.h
	src/gui/C4LoaderScreen.cpp
	src/gui/C4LoaderScreen.h
	src/gui/C4MainMenu.cpp
	src/gui/C4MainMenu.h
	src/gui/C4Menu.cpp
	src/gui/C4Menu.h
	src/gui/C4MessageBoard.cpp
	src/gui/C4MessageBoard.h
	src/gui/C4MessageInput.cpp
	src/gui/C4MessageInput.h
	src/gui/C4MouseControl.cpp
	src/gui/C4MouseControl.h
	src/gui/C4PlayerInfoListBox.cpp
	src/gui/C4PlayerInfoListBox.h
	src/gui/C4Scoreboard.cpp
	src/gui/C4Scoreboard.h
	src/gui/C4StartupAboutDlg.cpp
	src/gui/C4StartupAboutDlg.h
	src/gui/C4Startup.cpp
	src/gui/C4Startup.h
	src/gui/C4StartupMainDlg.cpp
	src/gui/C4StartupMainDlg.h
	src/gui/C4StartupNetDlg.cpp
	src/gui/C4StartupNetDlg.h
	src/gui/C4StartupOptionsDlg.cpp
	src/gui/C4StartupOptionsDlg.h
	src/gui/C4StartupPlrSelDlg.cpp
	src/gui/C4StartupPlrSelDlg.h
	src/gui/C4StartupScenSelDlg.cpp
	src/gui/C4StartupScenSelDlg.h
	src/gui/C4UpperBoard.cpp
	src/gui/C4UpperBoard.h
	src/landscape/C4Landscape.cpp
	src/landscape/C4Landscape.h
	src/landscape/C4LandscapeRenderClassic.cpp
	src/landscape/C4LandscapeRender.cpp
	src/landscape/C4LandscapeRender.h
	src/landscape/C4Map.cpp
	src/landscape/C4MapCreatorS2.cpp
	src/landscape/C4MapCreatorS2.h
	src/landscape/C4Map.h
	src/landscape/C4MassMover.cpp
	src/landscape/C4MassMover.h
	src/landscape/C4Material.cpp
	src/landscape/C4Material.h
	src/landscape/C4MaterialList.cpp
	src/landscape/C4MaterialList.h
	src/landscape/C4Particles.cpp
	src/landscape/C4Particles.h
	src/landscape/C4PathFinder.cpp
	src/landscape/C4PathFinder.h
	src/landscape/C4PXS.cpp
	src/landscape/C4PXS.h
	src/landscape/C4Region.cpp
	src/landscape/C4Region.h
	src/landscape/C4Scenario.cpp
	src/landscape/C4Scenario.h

=== docs/Makefile ===
# Notable targets:
# all (default): German and English onlinedocs
# online-en: only English onlinedocs, which can be partially updated
# Enwickler.chm: the German offline doc
#                use with make Entwickler.chm HHC = /path/to/hhc

# Extra Parameters for xsltproc can be given in the XSLTFLAGS variable.
# Use prefix to select the directory where the docs are to be installed

prefix = /tmp
HHC = hhc.exe
MKDIR_P = mkdir -p
CP = cp
CP_R = cp -r

stylesheet = clonk.xsl

# Sources:

# find all directories neither beginning nor contained within a directory beginning with a dot
sdk-dirs := $(shell find sdk -name '.*' -prune -o -type d -print)

# find all *.xml files recursively in sdk/
xmlfiles := $(sort $(shell find sdk -name '.*' -prune -o -name 'content.xml' -prune -o -name \*.xml -print))

# misc
extra-files := $(sort $(wildcard *.css *.php *.js images/*.*))
extra-files-chm := $(sort $(wildcard *.css *.js images/*.*))

# Targets:

# strip from all files the .xml, and add a .html
htmlfiles := $(addsuffix .html, $(basename $(xmlfiles)))

# The translated files and directories
sdk-de-dirs := $(subst sdk, sdk-de, $(sdk-dirs))

# For openclonk.org
online-dirs := $(foreach lang, en de, $(addprefix online/$(lang)/, $(sdk-dirs) images))
online-sdk-files := $(foreach lang, en de, $(addprefix online/$(lang)/, $(htmlfiles) sdk/content.html))
online-extra-files := $(foreach lang, en de, $(addprefix online/$(lang)/, $(extra-files)))

# For Entwickler.chm
chm-dirs := $(foreach lang, en de, $(addprefix chm/$(lang)/, . $(sdk-dirs) images))

.PHONY: all online-en chm install check clean

all: $(sdk-de-dirs) $(online-dirs) $(online-sdk-files) $(online-extra-files)

online-en: $(addprefix online/en/, $(sdk-dirs) images $(htmlfiles) sdk/content.html $(extra-files))

chm: $(sdk-de-dirs) $(chm-dirs) chm/en/Developer.chm chm/de/Entwickler.chm

install: all
	$(MKDIR_P) $(prefix)
	$(CP_R) $(PWD)/online/* $(prefix)

check:
	xmllint --noblanks --noout --valid $(xmlfiles)

clean:
	rm -f *.mo Entwickler.chm Developer.chm doku.pot sdk/content.xml
	rm -rf online sdk-de chm

sdk/content.xml: sdk/content.xml.in $(xmlfiles) build_contents.py experimental.py
	@echo generate $@
	@python build_contents.py $(xmlfiles)

chm/en/Output.hhp: $(xmlfiles) chm/en/. build_hhp.py Template.hhp
	@echo generate $@
	@python build_hhp.py $@ Template.hhp $(xmlfiles)
chm/de/Output.hhp: $(xmlfiles) chm/de/. build_hhp.py Template.de.hhp
	@echo generate $@
	@python build_hhp.py $@ Template.de.hhp $(xmlfiles)

$(sdk-de-dirs) $(online-dirs) $(chm-dirs):
	mkdir -p $@

doku.pot: $(xmlfiles) extra-strings.xml sdk/content.xml.in xml2po.py clonk.py
	@echo extract strings to $@
	@python xml2po.py -e -m clonk -o $@ $(xmlfiles) extra-strings.xml sdk/content.xml.in

%.po: doku.pot
	@echo update $@
#	@msgmerge --no-wrap -w 1 -U $@ $<
	@msgmerge --no-wrap -w 1 -o $@ $@ $<

%.mo: %.po
	@echo compile $@
	@msgfmt --statistics -o $@ $<

sdk-de/%.xml: sdk/%.xml de.mo xml2po.py clonk.py
	@echo generate $@
	@python xml2po.py -e -m clonk -t de.mo -o $@ $<

define run-xslt
@echo generate $@
@xsltproc -o $@ --param chm $(chm) --param fileext "'.html'" $(XSLTFLAGS) $(stylesheet) $<
endef
online/%: chm=0
chm/%: chm=1
online/en/sdk/%.html: sdk/%.xml $(stylesheet) ; $(run-xslt)
online/de/sdk/%.html: sdk-de/%.xml $(stylesheet) ; $(run-xslt)
chm/en/sdk/%.html: sdk/%.xml $(stylesheet) ; $(run-xslt)
chm/de/sdk/%.html: sdk-de/%.xml $(stylesheet) ; $(run-xslt)
chm/en/Output.hhc: stylesheet=hhc.xsl
chm/de/Output.hhc: stylesheet=hhc.xsl
chm/en/Output.hhc: sdk/content.xml hhc.xsl ; $(run-xslt)
chm/de/Output.hhc: sdk-de/content.xml hhc.xsl ; $(run-xslt)
chm/en/Output.hhk: stylesheet=hhk.xsl
chm/de/Output.hhk: stylesheet=hhk.xsl
chm/en/Output.hhk: sdk/content.xml hhk.xsl ; $(run-xslt)
chm/de/Output.hhk: sdk-de/content.xml hhk.xsl ; $(run-xslt)

$(filter online/en/%, $(online-extra-files)): online/en/%: %
	$(CP) $< $@
$(filter online/de/%, $(online-extra-files)): online/de/%: %
	$(CP) $< $@
$(addprefix chm/en/, $(extra-files-chm)): chm/en/%: %
	$(CP) $< $@
$(addprefix chm/de/, $(extra-files-chm)): chm/de/%: %
	$(CP) $< $@

chm/en/Developer.chm: chm/en/Output.hhp chm/en/Output.hhk chm/en/Output.hhc $(addprefix chm/en/, $(sdk-dirs) images $(htmlfiles) $(extra-files-chm))
	"$(HHC)" $<
chm/de/Entwickler.chm: chm/de/Output.hhp chm/de/Output.hhk chm/de/Output.hhc $(addprefix chm/de/, $(sdk-dirs) images $(htmlfiles) $(extra-files-chm))
	"$(HHC)" $<

=== tools/install_mac/Makefile ===

# Project data
NAME = OpenClonk
VERSION = 2.0

# Assume default XCode output directory
SOURCE_DIR = ../../Release
SOURCE_FILES = clonk.app

TEMPLATE_DMG = template.dmg

include fancy-dmg/Makefile

=== debian/changelog ===
openclonk (5.3.2-1) unstable; urgency=low

  * New upstream release.
    - Fixes FTBFS on some architectures (narrowing conversion to int8_t),
      but not all.
  * Drop fix-format-string-use.patch: applied upstream.
  * Add a manual page for openclonk.

 -- Philipp Kern <pkern@debian.org>  Mon, 19 Nov 2012 01:23:10 +0100

openclonk (5.3.1-1) unstable; urgency=low

  * Initial Debian release. (Closes: #531324)

 -- Philipp Kern <pkern@debian.org>  Sun, 21 Oct 2012 23:05:43 +0200

openclonk (5.1.2.4-0ubuntu1-ppa5) maverick; urgency=low

  * New Release

 -- Sebastian Rühl <sebastian.ruehl@mni.fh-giessen.de>  Sun, 31 Dec 2010 15:38:26 +0100

openclonk (5.1.1.0-0ubuntu1-ppa4) maverick; urgency=low

  * Mercurial as Build Dependency
  * Switch to cmake as build system
  * Fixed spacing issues in $(CURDIR)

 -- Sebastian Rühl <sebastian.ruehl@mni.fh-giessen.de>  Sun, 31 Dec 2010 15:38:26 +0100

openclonk (5.1.1.0-0ubuntu1-ppa3) maverick; urgency=low

  * Fixed Icons

 -- Sebastian Rühl <sebastian.ruehl@mni.fh-giessen.de>  Sun, 27 Dec 2010 15:23:05 +0200

openclonk (5.1.1.0-0ubuntu1-ppa2) maverick; urgency=low

  * Added Icons

 -- Sebastian Rühl <sebastian.ruehl@mni.fh-giessen.de>  Sun, 27 Dec 2010 12:23:05 +0200

openclonk (5.1.1.0-0ubuntu1-ppa1) maverick; urgency=low

  * Initial release

 -- Sebastian Rühl <sebastian.ruehl@mni.fh-giessen.de>  Sat, 25 Dec 2010 23:23:05 +0200

## openclonk 5.3.3

=== debian/changelog ===
openclonk (5.3.3-3) unstable; urgency=high

  * Add a patch to pre-compute Z values before face ordering. (Closes: #693750)

 -- Philipp Kern <pkern@debian.org>  Thu, 26 Dec 2013 16:34:01 +0100

openclonk (5.3.3-2) unstable; urgency=low

  * Include a patch by Guillem Jover to fix an XRandR-related crash
    on startup. (Closes: #704632)

 -- Philipp Kern <pkern@debian.org>  Sun, 15 Sep 2013 12:08:35 +0200

openclonk (5.3.3-1) unstable; urgency=low

  * New upstream bugfix release.

 -- Philipp Kern <pkern@debian.org>  Fri, 15 Mar 2013 17:45:54 +0100

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake -Bbuild

override_dh_auto_configure:
	dh_auto_configure -- -DWITH_AUTOMATIC_UPDATE=0

override_dh_auto_install:
	dh_auto_install
	mv debian/tmp/usr/share/applications/clonk.desktop \
		debian/tmp/usr/share/applications/openclonk.desktop
	sed -i -e 's/=clonk/=openclonk/g' debian/tmp/usr/share/applications/openclonk.desktop
	mv debian/tmp/usr/games/clonk debian/tmp/usr/games/openclonk

override_dh_strip:
	dh_strip --dbg-package=openclonk-dbg

override_dh_builddeb:
	dh_builddeb -- -Zxz

=== debian/watch ===
version=3
http://hg.openclonk.org/openclonk/archive/ openclonk-release-([\d\.]+)-src.tar.gz

## openclonk 5.4.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,27 +1,15 @@
 # OpenClonk, http://www.openclonk.org
 #
-# Copyright (c) 2009-2011  Günther Brammer
-# Copyright (c) 2009-2012  Nicolas Hake
-# Copyright (c) 2009  David Dormagen
-# Copyright (c) 2009-2012  Armin Burgmeier
-# Copyright (c) 2009-2010  Sven Eberhardt
-# Copyright (c) 2009  Tobias Zwick
-# Copyright (c) 2009  Richard Gerum
-# Copyright (c) 2010-2011  Julius Michaelis
-# Copyright (c) 2010-2011  Peter Wortmann
-# Copyright (c) 2010-2011  Martin Plicht
-# Copyright (c) 2010  Manuel Riecke
+# Copyright (c) 2009-2013, The OpenClonk Team and contributors
 #
-# Portions might be copyrighted by other authors who have contributed
-# to OpenClonk.
+# Distributed under the terms of the ISC license; see accompanying file
+# "COPYING" for details.
 #
-# Permission to use, copy, modify, and/or distribute this software for any
-# purpose with or without fee is hereby granted, provided that the above
-# copyright notice and this permission notice appear in all copies.
-# See isc_license.txt for full license and disclaimer.
+# "Clonk" is a registered trademark of Matthes Bender, used with permission.
+# See accompanying file "TRADEMARK" for details.
 #
-# "Clonk" is a registered trademark of Matthes Bender.
-# See clonk_trademark_license.txt for full license.
+# To redistribute this file separately, substitute the full license texts
+# for the above references.
 
 cmake_minimum_required (VERSION 2.6.0)
 project (openclonk CXX C)
@@ -29,7 +17,7 @@
 
 include(Version.txt)
 
-set(CMAKE_ADDITIONAL_DEPS_PATH deps CACHE PATH "Additional directory to search for libraries and headers")
+set(CMAKE_ADDITIONAL_DEPS_PATH "${CMAKE_CURRENT_BINARY_DIR}/deps" CACHE PATH "Additional directory to search for libraries and headers")
 list(APPEND CMAKE_PREFIX_PATH ${CMAKE_ADDITIONAL_DEPS_PATH})
 set(OC_CXX_FLAGS ${CMAKE_CXX_FLAGS})
 separate_arguments(OC_CXX_FLAGS)
@@ -40,54 +28,37 @@
 set(OC_EXE_LINKER_FLAGS_DEBUG ${CMAKE_EXE_LINKER_FLAGS_DEBUG})
 separate_arguments(OC_EXE_LINKER_FLAGS_DEBUG)
 
+function(unseparate_arguments _var _list)
+	foreach(_arg ${_list})
+		set(_string "${_string} ${_arg}")
+	endforeach()
+	set(${_var} "${_string}" PARENT_SCOPE)
+endfunction()
+
 ############################################################################
 # User selectable options
 ############################################################################
+include(CMakeDependentOption)
 option(PROJECT_FOLDERS "Put source files into subfolders in project file" ON)
-option(USE_GL "Enable OpenGL support" ON)
-SET(INITIAL_USE_SDL_MAINLOOP_VALUE OFF)
-SET(INITIAL_USE_OPEN_AL OFF)
-option(USE_SDL_MAINLOOP "Use SDL to create windows etc." ${INITIAL_USE_SDL_MAINLOOP_VALUE})
-if(WIN32 AND FALSE) # disable DX option while it doesn't work anyway
-	option(USE_DIRECTX "Enable DirectX support" ON)
-	if(EXISTS $ENV{DXSDK_DIR})
-		list(APPEND CMAKE_INCLUDE_PATH $ENV{DXSDK_DIR}/Include)
-		if(CMAKE_CL_64)
-			list(APPEND CMAKE_LIBRARY_PATH $ENV{DXSDK_DIR}/Lib/x64)
-		else()
-			list(APPEND CMAKE_LIBRARY_PATH $ENV{DXSDK_DIR}/Lib/x86)
-		endif()
-	else()
-
-	endif()
-else()
-	SET(USE_DIRECTX OFF)
-	SET(HAVE_FMOD OFF)
-endif()
-if(NOT USE_GL AND NOT USE_DIRECTX)
-	message(STATUS "No graphics display enabled; building dedicated server")
-	SET(USE_CONSOLE ON CACHE INTERNAL "Build dedicated server")
-endif()
-if(UNIX AND NOT USE_SDL_MAINLOOP AND NOT APPLE AND NOT USE_CONSOLE)
-	option(USE_X11 "Use X11 to create windows etc." ON)
-	option(USE_GTK "Use GTK for the developer mode" ON)
-	option(USE_GTK3 "Use GTK3 instead of GTK2" OFF)
-else()
-	SET(USE_X11 OFF)
-	SET(USE_GTK OFF)
-	SET(USE_GTK3 OFF)
-endif()
+option(USE_CONSOLE "Build dedicated server" OFF)
+CMAKE_DEPENDENT_OPTION(USE_SDL_MAINLOOP "Use SDL to create windows etc." OFF "NOT USE_CONSOLE" OFF)
+CMAKE_DEPENDENT_OPTION(USE_X11 "Use X11 to create windows etc." ON
+	"UNIX AND NOT APPLE AND NOT USE_SDL_MAINLOOP AND NOT USE_CONSOLE" OFF)
+CMAKE_DEPENDENT_OPTION(USE_GTK "Use GTK for the developer mode" ON "USE_X11" OFF)
+CMAKE_DEPENDENT_OPTION(USE_GTK3 "Use GTK3 instead of GTK2" OFF "USE_GTK" OFF)
+
+CMAKE_DEPENDENT_OPTION(USE_COCOA "Use Apple Cocoa for the developer mode and the windows." ON "APPLE" OFF)
+CMAKE_DEPENDENT_OPTION(USE_APPLE_CLANG "Use Apple Clang Compiler as C++ compiler." ON "APPLE" OFF)
 if(APPLE)
-	option(USE_COCOA "Use Apple Cocoa for the developer mode and the windows." ON)
-	option(USE_APPLE_CLANG "Use Apple Clang Compiler as C++ compiler." ON)
 	SET(INITIAL_USE_OPEN_AL ON)
 else()
-	option(USE_COCOA OFF)
+	SET(INITIAL_USE_OPEN_AL OFF)
 endif()
 option(USE_OPEN_AL "Use OpenAL to play sounds" ${INITIAL_USE_OPEN_AL})
-option(DEBUGREC "Debug records" OFF)
-option(OC_BUILD_MULTIPROCESSOR "Use all processor cores to build" OFF)
-option(WITH_AUTOMATIC_UPDATE "Build engine without automatic update support" OFF)
+option(WITH_AUTOMATIC_UPDATE "Automatic updates are downloaded from the project website." OFF)
+
+# Remove obsolete options
+unset(OC_BUILD_MULTIPROCESSOR CACHE)
 
 ############################################################################
 # Check for compiler quirks and features
@@ -111,20 +82,33 @@
 # out because it does not understand -std=gnu++0x
 set(SAFE_CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS}")
 set(CMAKE_REQUIRED_FLAGS ${OC_REQUIRED_FLAGS})
+include(RequireCXXSourceCompiles)
+if (NOT USE_APPLE_CLANG)
+REQUIRE_CXX_SOURCE_COMPILES("#include <memory>\nint main() { std::unique_ptr<int> a; std::shared_ptr<int> b; }" HAVE_C11_SMART_PTRS)
+endif()
 CHECK_CXX_SOURCE_COMPILES("void f(struct D&&); int main() { return 0; }" HAVE_RVALUE_REF)
 CHECK_CXX_SOURCE_COMPILES("int main() { void *d = nullptr; }" HAVE_NULLPTR)
 CHECK_CXX_SOURCE_COMPILES("int main() { static_assert(true, \"\"); }" HAVE_STATIC_ASSERT)
 set(CMAKE_REQUIRED_FLAGS "${SAFE_CMAKE_REQUIRED_FLAGS}")
 
+# g++'s libstdc++ doesn't properly support <regex> until 4.8.1 (maybe later?).
+# They ship a header that declares functions, but they don't ship an
+# implementation for some things (like std::regex_iterator).
+# This needs to test *linking*, not compilation; cmake does both at the same
+# time, so the test below works.
+CHECK_CXX_SOURCE_COMPILES("#include <regex>\nint main() { std::cregex_iterator ri; }" HAVE_WORKING_REGEX)
+CMAKE_DEPENDENT_OPTION(USE_BOOST_REGEX "Use Boost.Regex even if the C++ runtime has a working implementation of <regex>" OFF "HAVE_WORKING_REGEX" ON)
+
+# We link Boost statically because that makes it easier for us to distribute
+# the resulting binary. Distributions have the ability to guarantee a certain
+# version of the library exists on the system though, so they may prefer
+# dynamic linking.
+option(USE_STATIC_BOOST "Link Boost libraries statically" ON)
+
 if(MSVC_VERSION GREATER 1499)
-	# Activate minimal rebuild
-	if(OC_BUILD_MULTIPROCESSOR)
 		list(APPEND OC_CXX_FLAGS /MP)
 		list(REMOVE_ITEM OC_CXX_FLAGS_DEBUG /Gm)
-	else()
-		list(REMOVE_ITEM OC_CXX_FLAGS /MP)
-		list(APPEND OC_CXX_FLAGS_DEBUG /Gm)
-	endif()
+
 	if (NOT CMAKE_CL_64)
 		# Activate edit-and-continue
 		list(REMOVE_ITEM OC_CXX_FLAGS_DEBUG /Zi)
@@ -160,23 +144,11 @@
 # 	configurations.
 set(OC_CLONK_SOURCES
 	src/C4Globals.cpp
-	src/c4group/C4ComponentHost.cpp
-	src/c4group/C4ComponentHost.h
 	src/c4group/C4Components.h
 	src/c4group/C4Extra.cpp
 	src/c4group/C4Extra.h
-	src/c4group/C4Group.cpp
-	src/c4group/C4Group.h
-	src/c4group/C4GroupSet.cpp
-	src/c4group/C4GroupSet.h
-	src/c4group/C4LangStringTable.cpp
-	src/c4group/C4LangStringTable.h
 	src/c4group/C4Language.cpp
 	src/c4group/C4Language.h
-	src/c4group/C4Update.cpp
-	src/c4group/C4Update.h
-	src/c4group/CStdFile.cpp
-	src/c4group/CStdFile.h
 	src/C4Include.h
 	src/C4Prototypes.h
 	src/C4Version.h
@@ -239,13 +211,10 @@
 	src/graphics/Bitmap256.cpp
 	src/graphics/Bitmap256.h
 	src/graphics/C4Draw.cpp
-	src/graphics/C4DrawD3D.cpp
-	src/graphics/C4DrawD3D.h
-	src/graphics/C4DrawD3DShader.cpp
-	src/graphics/C4DrawD3DShader.h
 	src/graphics/C4DrawGL.cpp
 	src/graphics/C4DrawGLCtx.cpp
 	src/graphics/C4DrawGL.h
+	src/graphics/C4DrawMeshGL.cpp
 	src/graphics/C4DrawT.cpp
 	src/graphics/C4DrawT.h
 	src/graphics/C4Draw.h
@@ -253,8 +222,8 @@
 	src/graphics/C4FacetEx.cpp
 	src/graphics/C4FacetEx.h
 	src/graphics/C4Facet.h
-	src/graphics/C4Fonts.cpp
-	src/graphics/C4Fonts.h
+	src/graphics/C4FontLoader.cpp
+	src/graphics/C4FontLoader.h
 	src/graphics/C4GraphicsResource.cpp
 	src/graphics/C4GraphicsResource.h
 	src/graphics/C4Surface.cpp
@@ -339,6 +308,9 @@
 	src/landscape/C4MapCreatorS2.cpp
 	src/landscape/C4MapCreatorS2.h
 	src/landscape/C4Map.h
+	src/landscape/C4MapScript.cpp
+	src/landscape/C4MapScriptAlgo.cpp
+	src/landscape/C4MapScript.h
 	src/landscape/C4MassMover.cpp
 	src/landscape/C4MassMover.h
 	src/landscape/C4Material.cpp
@@ -351,7 +323,18 @@
 	src/landscape/C4PathFinder.h
 	src/landscape/C4PXS.cpp
 	src/landscape/C4PXS.h
-	src/landscape/C4Region.cpp
-	src/landscape/C4Region.h
 	src/landscape/C4Scenario.cpp
+	src/landscape/C4ScenarioSection.cpp
 	src/landscape/C4Scenario.h
+	src/landscape/C4Sky.cpp
+	src/landscape/C4Sky.h
+	src/landscape/C4SolidMask.cpp
+	src/landscape/C4SolidMask.h
+	src/landscape/C4Texture.cpp
+	src/landscape/C4Texture.h
+	src/landscape/C4Weather.cpp
+	src/landscape/C4Weather.h
+	src/lib/C4LogBuf.cpp
+	src/lib/C4LogBuf.h
+	src/lib/C4Log.cpp
+	src/lib/C4Log.h

=== docs/Makefile ===
--- 
+++ 
@@ -1,8 +1,15 @@
-# Notable targets:
-# all (default): German and English onlinedocs
-# online-en: only English onlinedocs, which can be partially updated
-# Enwickler.chm: the German offline doc
-#                use with make Entwickler.chm HHC = /path/to/hhc
+# German and English online docs:
+#   make all
+#   make install prefix=/path/to/webspace
+# The offline docs:
+#   make chm HHC=/path/to/hhc.exe
+
+# Only English online docs, which can be partially updated:
+#   make online-en
+# The English offline doc:
+#   make chm/en/Developer.chm HHC=/path/to/hhc.exe
+# XML syntax check:
+#   make check
 
 # Extra Parameters for xsltproc can be given in the XSLTFLAGS variable.
 # Use prefix to select the directory where the docs are to be installed
@@ -53,10 +60,10 @@
 
 install: all
 	$(MKDIR_P) $(prefix)
-	$(CP_R) $(PWD)/online/* $(prefix)
+	$(CP_R) online/* $(prefix)
 
 check:
-	xmllint --noblanks --noout --valid $(xmlfiles)
+	@xmllint --noblanks --noout --valid $(xmlfiles)
 
 clean:
 	rm -f *.mo Entwickler.chm Developer.chm doku.pot sdk/content.xml
@@ -122,7 +129,7 @@
 	$(CP) $< $@
 
 chm/en/Developer.chm: chm/en/Output.hhp chm/en/Output.hhk chm/en/Output.hhc $(addprefix chm/en/, $(sdk-dirs) images $(htmlfiles) $(extra-files-chm))
-	"$(HHC)" $<
+	! "$(HHC)" $<
 chm/de/Entwickler.chm: chm/de/Output.hhp chm/de/Output.hhk chm/de/Output.hhc $(addprefix chm/de/, $(sdk-dirs) images $(htmlfiles) $(extra-files-chm))
-	"$(HHC)" $<
+	! "$(HHC)" $<

=== tests/CMakeLists.txt ===
# OpenClonk, http://www.openclonk.org
#
# Copyright (c) 2013 Oliver Schneider
#
# Portions might be copyrighted by other authors who have contributed
# to OpenClonk.
#
# Permission to use, copy, modify, and/or distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
# See isc_license.txt for full license and disclaimer.
#
# "Clonk" is a registered trademark of Matthes Bender.
# See clonk_trademark_license.txt for full license.

cmake_minimum_required (VERSION 2.6.0)
project(openclonk_unittest)

# used by c4script and by the unit tests
set(C4SCRIPT_SOURCES
	../include/c4script/c4script.h
	../src/lib/C4SimpleLog.cpp
	../src/C4Include.cpp
	../src/script/C4ScriptStandalone.cpp
)

if (UNIX)
    list(APPEND CMAKE_PREFIX_PATH /usr/src)
endif()

# GTest
find_path(GTEST_INCLUDE_DIR gtest/gtest.h)
find_path(GTEST_SOURCE_DIR gtest/CMakeLists.txt)

if (GTEST_INCLUDE_DIR AND GTEST_SOURCE_DIR)
    add_subdirectory(${GTEST_SOURCE_DIR}/gtest gtest)
    include_directories(${GTEST_INCLUDE_DIR})
    set(GTEST_LIBRARIES gtest gtest_main)
    AUX_SOURCE_DIRECTORY(. TESTS_SOURCES)
    add_executable(tests ${TESTS_SOURCES} ${C4SCRIPT_SOURCES})
    target_link_libraries(tests ${GTEST_LIBRARIES} libc4script libmisc)
    if(UNIX AND NOT APPLE)
	    target_link_libraries(tests rt)
    endif()
    if(HAVE_PTHREAD)
	    target_link_libraries(tests pthread)
    endif()
else()
    if (NOT GTEST_INCLUDE_DIR)
        message(STATUS "Could NOT find Gtest (missing gtest/gtest.h)")
    endif()
    if(NOT GTEST_SOURCE_DIR)
        message(STATUS "Could NOT find Gtest (gtest/CMakeLists.txt)")
    endif()
endif()

=== thirdparty/tinyxml/CMakeLists.txt ===
add_library(tinyxml
	tinystr.cpp
	tinystr.h
	tinyxml.cpp
	tinyxml.h
	tinyxmlerror.cpp
	tinyxmlparser.cpp
)

=== debian/changelog ===
openclonk (5.4.1-1) unstable; urgency=medium

  * Imported Upstream version 5.4.1 (bugfix release). (Closes: #733936)
    - Drop find-freetype-without-prefix.patch; applied upstream.
    - Drop do-not-link-boost-statically.patch; now configurable upstream.
  * Re-add menu support, thanks to Markus Koschany. (Closes: #737992)
  * Install icons into the data package.
  * Fix two spelling mistakes in the openclonk manpage.
  * Install the upstream-provided desktop file.
  * Do not build-depend on a specific version of boost-regex.
  * Do not build-depend on a specific version of libupnp.
  * debian/watch: update source code URL

 -- Philipp Kern <pkern@debian.org>  Sun, 16 Mar 2014 17:42:45 +0100

openclonk (5.4.0-1) unstable; urgency=medium

  * Imported Upstream version 5.4.0
  * Rework debian/copyright based on the new upstream release.
  * Dropped change-data-directory.patch: merged upstream.
  * Dropped move-clonk-to-usr-games.patch: merged upstream.
  * Dropped Pre-compute-Z-values-before-face-ordering-984.patch: included in
    the new release.
  * Dropped xrandr-primary-output.patch: solved differently upstream.
  * Add new build-dependencies: upnp, freetype, boost-regex.
  * Fix Freetype include path lookup made by CMake.
  * Do not link boost-regex statically.
  * Remove clonk to openclonk renaming.
  * Get rid of the X11 pixmap for the menu entry (dropped upstream).
  * Fix a typo in the package description.

 -- Philipp Kern <pkern@debian.org>  Fri, 31 Jan 2014 22:15:04 +0100

=== debian/control ===
Source: openclonk
Section: games
Priority: optional
Maintainer: Philipp Kern <pkern@debian.org>
Build-Depends: debhelper (>= 9), cmake, libx11-dev, libxxf86vm-dev, libxrandr-dev, libxpm-dev, libglew-dev, libgl1-mesa-dev, libpng12-dev, libssl-dev, libsdl1.2-dev, libsdl-mixer1.2-dev, libgtk2.0-dev, libjpeg-dev, zlib1g-dev, libboost-dev, libupnp-dev, libfreetype6-dev, libboost-regex-dev, imagemagick
Standards-Version: 3.9.3
Homepage: http://www.openclonk.org
VCS-Git: git://git.0x539.de/git/users/pkern/openclonk-debian.git
VCS-Browser: http://git.0x539.de/?p=users/pkern/openclonk-debian.git;a=summary

Package: openclonk
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, openclonk-data (= ${source:Version})
Description: multiplayer game of strategy, action and skill
 OpenClonk is a free multiplayer action game where you control clonks,
 small but witty and nimble humanoid beings. The game is mainly about
 mining, settling and fast-paced melees. OpenClonk is also not just a
 game but also a versatile 2D game engine that offers countless
 possibilities to make own mods.
 .
 This package contains the OpenClonk engine.

Package: openclonk-data
Architecture: all
Depends: ${misc:Depends}
Recommends: openclonk
Description: multiplayer game of strategy, action and skill - data
 OpenClonk is a free multiplayer action game where you control clonks,
 small but witty and nimble humanoid beings. The game is mainly about
 mining, settling and fast-paced melees. OpenClonk is also not just a
 game but also a versatile 2D game engine that offers countless
 possibilities to make own mods.
 .
 This package contains the game data.

Package: openclonk-dbg
Section: debug
Priority: extra
Architecture: any
Depends: ${misc:Depends}, openclonk (= ${binary:Version})
Description: multiplayer game of strategy, action and skill - debug symbols
 OpenClonk is a free multiplayer action game where you control clonks,
 small but witty and nimble humanoid beings. The game is mainly about
 mining, settling and fast-paced melees. OpenClonk is also not just a
 game but also a versatile 2D game engine that offers countless
 possibilities to make own mods.
 .
 This package contains the debugging symbols. It is usually not needed.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake -Bbuild

override_dh_auto_configure:
	dh_auto_configure -- -DWITH_AUTOMATIC_UPDATE=0 -DUSE_STATIC_BOOST=OFF

override_dh_strip:
	dh_strip --dbg-package=openclonk-dbg

override_dh_builddeb:
	dh_builddeb -- -Zxz

override_dh_auto_build-indep:
	convert -monitor src/res/oc32.png oc32.xpm

## openclonk 5.5.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # OpenClonk, http://www.openclonk.org
 #
-# Copyright (c) 2009-2013, The OpenClonk Team and contributors
+# Copyright (c) 2009-2014, The OpenClonk Team and contributors
 #
 # Distributed under the terms of the ISC license; see accompanying file
 # "COPYING" for details.
@@ -11,7 +11,7 @@
 # To redistribute this file separately, substitute the full license texts
 # for the above references.
 
-cmake_minimum_required (VERSION 2.6.0)
+cmake_minimum_required (VERSION 2.8.4)
 project (openclonk CXX C)
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 
@@ -48,62 +48,49 @@
 CMAKE_DEPENDENT_OPTION(USE_GTK3 "Use GTK3 instead of GTK2" OFF "USE_GTK" OFF)
 
 CMAKE_DEPENDENT_OPTION(USE_COCOA "Use Apple Cocoa for the developer mode and the windows." ON "APPLE" OFF)
-CMAKE_DEPENDENT_OPTION(USE_APPLE_CLANG "Use Apple Clang Compiler as C++ compiler." ON "APPLE" OFF)
-if(APPLE)
-	SET(INITIAL_USE_OPEN_AL ON)
-else()
-	SET(INITIAL_USE_OPEN_AL OFF)
-endif()
-option(USE_OPEN_AL "Use OpenAL to play sounds" ${INITIAL_USE_OPEN_AL})
 option(WITH_AUTOMATIC_UPDATE "Automatic updates are downloaded from the project website." OFF)
+
+# We link Boost statically because that makes it easier for us to distribute
+# the resulting binary. Distributions have the ability to guarantee a certain
+# version of the library exists on the system though, so they may prefer
+# dynamic linking.
+option(USE_STATIC_BOOST "Link Boost libraries statically" ON)
 
 # Remove obsolete options
 unset(OC_BUILD_MULTIPROCESSOR CACHE)
+unset(USE_APPLE_CLANG CACHE)
 
 ############################################################################
 # Check for compiler quirks and features
 ############################################################################
 include(CheckCXXCompilerFlag)
-if(CMAKE_COMPILER_IS_GNUCXX)
-	CHECK_CXX_COMPILER_FLAG("-std=gnu++0x" USE_GCC_STD_0X)
-	if(USE_GCC_STD_0X)
-		list(APPEND OC_CXX_FLAGS "-std=gnu++0x")
-	endif()
-endif()
-
-# ck 09-09-20: CMAKE_REQUIRED_FLAGS requires a string, not a list.
 include(CheckCXXSourceCompiles)
+include(RequireCXXSourceCompiles)
+
+CHECK_CXX_COMPILER_FLAG("-std=gnu++0x" USE_GCC_STD_0X)
+if(USE_GCC_STD_0X)
+	list(APPEND OC_CXX_FLAGS "-std=gnu++0x")
+endif()
+
+# Convert the OC_CXX_FLAGS list to a CMAKE_CXX_FLAGS string
 foreach(FLAG ${OC_CXX_FLAGS})
 	set(OC_REQUIRED_FLAGS "${OC_REQUIRED_FLAGS} ${FLAG}")
 endforeach()
 
-# ck 10-09-04: Reset CMAKE_REQUIRED_FLAGS after having done the C++0x checks
-# otherwise they are used for C library checks as well and the C compiler bails
-# out because it does not understand -std=gnu++0x
-set(SAFE_CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS}")
-set(CMAKE_REQUIRED_FLAGS ${OC_REQUIRED_FLAGS})
-include(RequireCXXSourceCompiles)
-if (NOT USE_APPLE_CLANG)
+set(CMAKE_CXX_FLAGS ${OC_REQUIRED_FLAGS})
+
 REQUIRE_CXX_SOURCE_COMPILES("#include <memory>\nint main() { std::unique_ptr<int> a; std::shared_ptr<int> b; }" HAVE_C11_SMART_PTRS)
-endif()
 CHECK_CXX_SOURCE_COMPILES("void f(struct D&&); int main() { return 0; }" HAVE_RVALUE_REF)
 CHECK_CXX_SOURCE_COMPILES("int main() { void *d = nullptr; }" HAVE_NULLPTR)
 CHECK_CXX_SOURCE_COMPILES("int main() { static_assert(true, \"\"); }" HAVE_STATIC_ASSERT)
-set(CMAKE_REQUIRED_FLAGS "${SAFE_CMAKE_REQUIRED_FLAGS}")
-
-# g++'s libstdc++ doesn't properly support <regex> until 4.8.1 (maybe later?).
+
+# g++'s libstdc++ doesn't properly support <regex> until 4.9.
 # They ship a header that declares functions, but they don't ship an
 # implementation for some things (like std::regex_iterator).
 # This needs to test *linking*, not compilation; cmake does both at the same
 # time, so the test below works.
 CHECK_CXX_SOURCE_COMPILES("#include <regex>\nint main() { std::cregex_iterator ri; }" HAVE_WORKING_REGEX)
 CMAKE_DEPENDENT_OPTION(USE_BOOST_REGEX "Use Boost.Regex even if the C++ runtime has a working implementation of <regex>" OFF "HAVE_WORKING_REGEX" ON)
-
-# We link Boost statically because that makes it easier for us to distribute
-# the resulting binary. Distributions have the ability to guarantee a certain
-# version of the library exists on the system though, so they may prefer
-# dynamic linking.
-option(USE_STATIC_BOOST "Link Boost libraries statically" ON)
 
 if(MSVC_VERSION GREATER 1499)
 		list(APPEND OC_CXX_FLAGS /MP)
@@ -338,3 +325,29 @@
 	src/lib/C4LogBuf.h
 	src/lib/C4Log.cpp
 	src/lib/C4Log.h
+	src/lib/C4NameList.cpp
+	src/lib/C4NameList.h
+	src/lib/C4Rect.cpp
+	src/lib/C4Rect.h
+	src/lib/C4RTF.cpp
+	src/lib/C4RTF.h
+	src/lib/C4Stat.cpp
+	src/lib/C4Stat.h
+	src/lib/PathFinder.cpp
+	src/lib/PathFinder.h
+	src/lib/StdAdaptors.h
+	src/lib/StdColors.h
+	src/lib/StdMesh.cpp
+	src/lib/StdMesh.h
+	src/lib/StdMeshLoaderBinaryChunks.cpp
+	src/lib/StdMeshLoaderBinaryChunks.h
+	src/lib/StdMeshLoaderBinary.cpp
+	src/lib/StdMeshLoaderDataStream.h
+	src/lib/StdMeshLoader.h
+	src/lib/StdMeshLoaderXml.cpp
+	src/lib/StdMeshMaterial.cpp
+	src/lib/StdMeshMaterial.h
+	src/lib/StdMeshMath.cpp
+	src/lib/StdMeshMath.h
+	src/lib/StdMeshUpdate.cpp
+	src/lib/StdMeshUpdate.h

=== debian/changelog ===
openclonk (5.5.1-2) unstable; urgency=medium

  * Use the system tinyxml.

 -- Philipp Kern <pkern@debian.org>  Wed, 15 Oct 2014 00:06:11 +0200

openclonk (5.5.1-1) unstable; urgency=medium

  * Imported Upstream version 5.5.1
  * Bump minimum cmake version in build-depends.

 -- Philipp Kern <pkern@debian.org>  Mon, 13 Oct 2014 23:11:57 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: games
 Priority: optional
 Maintainer: Philipp Kern <pkern@debian.org>
-Build-Depends: debhelper (>= 9), cmake, libx11-dev, libxxf86vm-dev, libxrandr-dev, libxpm-dev, libglew-dev, libgl1-mesa-dev, libpng12-dev, libssl-dev, libsdl1.2-dev, libsdl-mixer1.2-dev, libgtk2.0-dev, libjpeg-dev, zlib1g-dev, libboost-dev, libupnp-dev, libfreetype6-dev, libboost-regex-dev, imagemagick
+Build-Depends: debhelper (>= 9), cmake (>= 2.8.4), libx11-dev, libxxf86vm-dev, libxrandr-dev, libxpm-dev, libglew-dev, libgl1-mesa-dev, libpng12-dev, libssl-dev, libsdl1.2-dev, libsdl-mixer1.2-dev, libgtk2.0-dev, libjpeg-dev, zlib1g-dev, libboost-dev, libupnp-dev, libfreetype6-dev, libboost-regex-dev, imagemagick, libtinyxml-dev
 Standards-Version: 3.9.3
 Homepage: http://www.openclonk.org
 VCS-Git: git://git.0x539.de/git/users/pkern/openclonk-debian.git

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,7 @@
 	dh $@ --buildsystem=cmake -Bbuild
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DWITH_AUTOMATIC_UPDATE=0 -DUSE_STATIC_BOOST=OFF
+	dh_auto_configure -- -DWITH_AUTOMATIC_UPDATE=0 -DUSE_STATIC_BOOST=OFF -DWITH_SYSTEM_TINYXML=ON
 
 override_dh_strip:
 	dh_strip --dbg-package=openclonk-dbg
